--   
insert into LayerFields(RecordIndex, FieldName, DisplayLabel, ClsName, FieldType, AGGREGATIONTYPE, FieldRole, FieldPosition)
select distinct l.ID, '', ' ', '.', 13, 1, 5, 990000000
from Layers l join LayerFields lf on (l.ID = lf.RecordIndex) left join layerfields elf on (l.ID = elf.RecordIndex and elf.FieldName = '')
where l.Alias not like '%..%' and l.TableName in ('LayerData', 'LayerData_Float')
and (l.Alias like '%...%'
  or l.Alias like '%..%'
  or l.Alias like '%..%')
and (lf.clsname = '.')
and elf.id is null;

--   
insert into LayerFields(RecordIndex, FieldName, DisplayLabel, DBName, FieldType, FieldTypeRef, FieldRole, LinkedField, LinkedName)
select distinct l.ID, '', ' ', 'TARGETCLS', 21, (select ID from LayerFieldTypes where Alias = '..'), 1,
mlf.ID, case when mlf.ID is not null then '' else null end
from Layers l join LayerFields lf on (l.ID = lf.RecordIndex)
left join LayerFields elf on (l.ID = elf.RecordIndex and elf.FieldName = '') --   
left join LayerFields mlf on (l.ID = mlf.RecordIndex and mlf.FieldName = '') --  
where l.Alias not like '%..%' and l.TableName in ('LayerData', 'CalcData')
and (l.Alias like '%...%'
  or l.Alias like '%..%'
  or l.Alias like '%..%')
and ( 
lf.FieldTypeRef = (select ID from LayerFieldTypes where Alias = '..')
or lf.Formula1 = '@.'
)
and elf.ID is null;


update LayerFields elf
set elf.FieldPosition = 
    (
        select max(plf.FieldPosition)+100000
        from Layers l, LayerFields lf, LayerFields plf
        where l.ID = lf.RecordIndex and l.ID = elf.RecordIndex and l.ID = plf.RecordIndex
        and l.Alias not like '%..%' and l.TableName in ('LayerData', 'CalcData')
        and (l.Alias like '%...%'
          or l.Alias like '%..%'
          or l.Alias like '%..%')
        and ( 
                lf.FieldTypeRef = (select ID from LayerFieldTypes where Alias = '..')
                or lf.Formula1 = '@.'
            )
        and plf.FieldPosition between (lf.FieldPosition / 1000000 * 1000000) and (lf.FieldPosition / 1000000 * 1000000 + 9900000)
    )
where elf.FieldName = '' and elf.FieldPosition = 0 and elf.RecordIndex in
(
    select l.id from Layers l where l.Alias not like '%..%' and l.TableName in ('LayerData', 'CalcData')
    and (l.Alias like '%...%'
      or l.Alias like '%..%'
      or l.Alias like '%..%')
);

commit work;

